
var CAPICOM_STORE_OPEN_READ_ONLY = 0;
var CAPICOM_CURRENT_USER_STORE = 2;
var CAPICOM_CERTIFICATE_FIND_SHA1_HASH = 0;
var CAPICOM_CERTIFICATE_FIND_EXTENDED_PROPERTY = 6;
var CAPICOM_CERTIFICATE_FIND_TIME_VALID = 9;
var CAPICOM_CERTIFICATE_FIND_KEY_USAGE = 12;
var CAPICOM_DIGITAL_SIGNATURE_KEY_USAGE = 0x00000080;
var CAPICOM_AUTHENTICATED_ATTRIBUTE_SIGNING_TIME = 0;
var CAPICOM_INFO_SUBJECT_SIMPLE_NAME = 0;
var CAPICOM_ENCODE_BASE64 = 0;
var CAPICOM_E_CANCELLED = -2138568446;
var CERT_KEY_SPEC_PROP_ID = 6;

function getIECertificate()
{
    var MyStore = new ActiveXObject("CAPICOM.Store");
    var FilteredCertificates = new ActiveXObject("CAPICOM.Certificates");

    try
    {
        MyStore.Open(CAPICOM_CURRENT_USER_STORE, "My", CAPICOM_STORE_OPEN_READ_ONLY);
    }
    catch (e)
    {
        if (e.number != CAPICOM_E_CANCELLED)
        {
            alert("An error occurred while opening your personal certificate store, aborting");
            return false;
        }
    }
    var FilteredCertificates = MyStore.Certificates.Find(CAPICOM_CERTIFICATE_FIND_KEY_USAGE).Find(CAPICOM_CERTIFICATE_FIND_EXTENDED_PROPERTY,CERT_KEY_SPEC_PROP_ID);

    return FilteredCertificates.Select();
}

function signTextIE(text)
{
    var signedData = new ActiveXObject("CAPICOM.SignedData");
    var signer = new ActiveXObject("CAPICOM.Signer");
    var cert = getIECertificate();
    var sign = "";

    signer.Certificate = cert.Item(1);
    signedData.Content = text;
    try
    {
        sign = signedData.Sign(signer, true, CAPICOM_ENCODE_BASE64);
    }
    catch (e)
    {
        if (e.number != CAPICOM_E_CANCELLED)
        {
            alert("An error occurred when attempting to sign the content, the errot was: " + e.description);
            return false;
        }
    }

    return sign;
}

function signText(form, text)
{
    var i;
    var sign = "";

    if (navigator.appName == "Netscape")
        sign = crypto.signText(decodeURI(text), "auto");
    else if (navigator.appName == "Microsoft Internet Explorer")
        sign = signTextIE(decodeURI(text));
    else
        alert("Unsupported Browser");
    sign = encodeURI(sign);
    sign = sign.replace(/%0D%0A$/, "");
    form.signature.value = sign;
}

$(document).ready(function() {
        $("form.quixote").show();
        });

