# w.c.s. - web application for online forms
# Copyright (C) 2005-2013  Entr'ouvert
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.

from qommon.form import *
from qommon import ezt

from wcs.workflows import WorkflowStatusItem, register_item_class, template_on_formdata


class RegisterCommenterWorkflowStatusItem(WorkflowStatusItem):
    description = N_('Record in Journal')
    key = 'register-comment'

    comment = None

    def add_parameters_widgets(self, form, parameters, prefix='', formdef=None):
        if 'comment' in parameters:
            form.add(TextWidget, '%scomment' % prefix, title=_('Comment'),
                value=self.comment, cols=80, rows=10)

    def get_parameters(self):
        return ('comment',)

    def perform(self, formdata):
        if not formdata.evolution:
            return
        try:
            formdata.evolution[-1].comment = template_on_formdata(formdata, self.comment)
            formdata.store()
        except ezt.EZTException:
            url = formdata.get_url()
            get_logger().error('error in template for comment [%s], comment could not be generated' % url)


register_item_class(RegisterCommenterWorkflowStatusItem)
